package com.outr.webcommunicator.netty

import handler.RequestHandler
import org.jboss.netty.channel.{MessageEvent, ChannelHandlerContext}
import org.jboss.netty.handler.codec.http.HttpRequest
import java.net.URL

/**
 * @author Matt Hicks <matt@outr.com>
 */
case class URLResource(path: String, url: URL) extends WebResource with RequestHandler {
  def request(webapp: NettyWebapp, context: ChannelHandlerContext, event: MessageEvent) = event.getMessage match {
    case request: HttpRequest if (request != null && request.path == path) => Some(this)
    case _ => None
  }

  def apply(webapp: NettyWebapp, context: ChannelHandlerContext, event: MessageEvent) = {
    streamURL(url, context, event.getMessage.asInstanceOf[HttpRequest])
  }
}

object URLResource {
  def apply(path: String, resource: String): URLResource = URLResource(path, getClass.getClassLoader.getResource(resource))
}